hallo da ich noch keinen wirklich guten sh script guide gefunden habe frag ich einfach mal hier ^^
wie kann eich eine option an das script hängen wie zb:
./script.sh --muh
bsp:
<--teil1-->
echo "nix option";
exit;
<--teil2-->
echo "Muh-Option";
exit;
wenn keine option dran ist soll es teil 1 nehmen wenn option --muh angehänt ist teil 2 wie mach ich das?
optionen ans script hängen
ein kleines Beispiel mit einer Long-Option "--muh" und einer Short-Option "-v"
Gruß
gms
Code: Alles auswählen
root@gms1:~# cat x.sh
#!/bin/bash
RES=`getopt -o "v" --long "muh" -- "$@"`
if [ $? != 0 ] ; then echo "usage error" >&2 ; exit 1 ; fi
eval set -- "$RES"
while true ; do
case "$1" in
-v) echo "option v detected" ; shift ;;
--muh) echo "option muh detected" ; shift ;;
--) shift ; break ;;
*) echo "usage error!" >&2; exit 1 ;;
esac
done
echo "$@"
root@gms1:~# ./x.sh --muh arg1 -v arg2
option muh detected
option v detected
arg1 arg2
gms
mehrere Long-Options können mit "," getrennt werden und die "-o" Option wird glaube ich benötigt
Code: Alles auswählen
gms@gms4:~$ cat x.sh
#!/bin/bash
RES=`getopt -o "" --long "muh,grunz" -- "$@"`
if [ $? != 0 ] ; then echo "usage error" >&2 ; exit 1 ; fi
eval set -- "$RES"
while true ; do
case "$1" in
--muh) echo "option muh detected" ; shift ;;
--grunz) echo "option grunz detected" ; shift ;;
--) shift ; break ;;
*) echo "usage error!" >&2; exit 1 ;;
esac
done
echo "$@"
gms@gms4:~$ ./x.sh --muh arg1 --grunz arg2
option muh detected
option grunz detected
arg1 arg2